import { providers, ContractTransaction, Contract } from 'ethers';
import { Certificate, IClaimData, ICertificate } from './Certificate';
import { IBlockchainEvent } from '../utils/events';
import { IBlockchainProperties } from './BlockchainProperties';
export interface IShareInCertificate {
    [address: string]: string;
}
export declare const encodeClaimData: (claimData: IClaimData, blockchainProperties: IBlockchainProperties) => Promise<string>;
export declare const decodeClaimData: (encodedClaimData: string, blockchainProperties: IBlockchainProperties) => Promise<IClaimData>;
export declare function claimCertificates(certificateIds: number[], claimData: IClaimData, blockchainProperties: IBlockchainProperties, forAddress?: string): Promise<ContractTransaction>;
export declare function transferCertificates(certificateIds: number[], to: string, blockchainProperties: IBlockchainProperties, from?: string): Promise<ContractTransaction>;
export declare function getAllCertificates(blockchainProperties: IBlockchainProperties): Promise<Certificate[]>;
export declare function getAllOwnedCertificates(blockchainProperties: IBlockchainProperties): Promise<Certificate[]>;
export declare function decodeEvent(eventName: string, event: providers.Log, contract: Contract): Promise<IBlockchainEvent>;
export declare const getAllCertificateEvents: (certId: number, blockchainProperties: IBlockchainProperties) => Promise<IBlockchainEvent[]>;
export declare const calculateOwnership: (certificateId: ICertificate['id'], blockchainProperties: IBlockchainProperties) => Promise<IShareInCertificate>;
export declare const calculateClaims: (certificateId: ICertificate['id'], blockchainProperties: IBlockchainProperties) => Promise<IShareInCertificate>;
export declare function approveOperator(operator: string, blockchainProperties: IBlockchainProperties): Promise<ContractTransaction>;
